"""
===============
循环检测
===============

这个示例展示了如何使用 ``nx.find_cycle`` 在一个图中找到一个任意的单个循环。

其他函数如 ``nx.simple_cycles`` 和 ``nx.cycle_basis`` 可以用来找到所有循环或一个循环基。
"""

import networkx as nx
import matplotlib.pyplot as plt

# 创建一个带有环的简单有向图
G = nx.DiGraph([(1, 2), (2, 3), (3, 4), (4, 2), (3, 5), (3, 2), (1, 5)])

# Draw the graph
pos = nx.spring_layout(G, seed=8020)
nx.draw(G, pos, with_labels=True)

# `orientation`参数可以用来确定有向边的方向
# 处理并报告循环中的边缘方向
cycle = nx.find_cycle(G, orientation="original")
print(cycle)

# 将循环部分高亮显示为红色
nx.draw_networkx_edges(G, pos, edgelist=cycle, edge_color="r", width=2)
plt.show()
