"""
==========
戴维斯俱乐部
==========

戴维斯南方俱乐部女性

展示了如何制作图的单部分投影并计算这些图的属性。

这些数据是由戴维斯等人于20世纪30年代收集的。
它们代表了18位南方女性在14次社交活动中的观察出席情况。
该图是二部分的（俱乐部，女性）。
"""

import matplotlib.pyplot as plt
import networkx as nx
from networkx.algorithms import bipartite

G = nx.davis_southern_women_graph()
women = G.graph["top"]
clubs = G.graph["bottom"]

print("Biadjacency matrix")
print(bipartite.biadjacency_matrix(G, women, clubs))

# 将二分图投影到女性节点上
W = bipartite.projected_graph(G, women)
print()
print("#Friends, Member")
for w in women:
    print(f"{W.degree(w)} {w}")

# 将二分图投影到女性节点上，保持共现次数
# 计算的度是加权的，并统计共享联系人的总数
W = bipartite.weighted_projected_graph(G, women)
print()
print("#Friend meetings, Member")
for w in women:
    print(f"{W.degree(w, weight='weight')} {w}")

pos = nx.spring_layout(G, seed=648)  # 为可重复的节点位置设置种子布局
nx.draw(G, pos)
plt.show()
