"""
====================
自定义节点位置
====================

绘制一个图，其中节点位于用户定义的位置。

当用户设置了一个位置时，其他节点仍然可以整齐地组织在一个布局中。
"""

import networkx as nx
import numpy as np

G = nx.path_graph(20)  # 一个示例图
center_node = 5  # 或者任何其他节点位于中心
edge_nodes = set(G) - {center_node}
# 确保圆周上的节点均匀分布
pos = nx.circular_layout(G.subgraph(edge_nodes))
pos[center_node] = np.array([0, 0])  # 手动指定节点位置
nx.draw(G, pos, with_labels=True)
