"""
========================
期望的度序列
========================

根据给定的度序列生成随机图。
"""

import networkx as nx

# 生成一个包含500个节点、期望度数为50的随机图
n = 500  # n个节点
p = 0.1
w = [p * n for i in range(n)]  # w = p*n 对于所有节点
G = nx.expected_degree_graph(w)  # 配置模型
print("Degree histogram")
print("degree (#nodes) ****")
dh = nx.degree_histogram(G)
for i, d in enumerate(dh):
    print(f"{i:2} ({d:2}) {'*'*d}")
