"""
二维网格
=======

演示如何结合使用 `~networkx.drawing.nx_agraph.write_dot` 与 Graphviz 命令行接口来创建可视化图形。
"""

import matplotlib.pyplot as plt
import networkx as nx

# %%
# 从networkx图写入一个dot文件，以便进一步使用graphviz进行处理。

G = nx.grid_2d_graph(5, 5)  # 5x5 grid
# 这个示例需要 Graphviz 和 PyGraphviz
nx.nx_agraph.write_dot(G, "grid.dot")
# 创建了dot文件后，可以通过命令行调用graphviz
# 在磁盘上生成图像，例如：
print("Now run: neato -Tps grid.dot >grid.ps")

# 或者，可以通过AGraph.draw直接创建图像
A = nx.nx_agraph.to_agraph(G)
A.draw("5x5.png", prog="neato")
