"""
Atlas
=====

一个示例，展示如何将图集中的前20个图写成graphviz的dot文件，文件名为Gn.dot，其中n=0,19。

待办事项：nx_agraph.draw是否支持在一个png中绘制多个图？
"""

import networkx as nx

atlas = nx.graph_atlas_g()[0:20]

for G in atlas:
    print(G)
    A = nx.nx_agraph.to_agraph(G)
    A.graph_attr["label"] = G.name
    # 设置默认节点属性
    A.node_attr["color"] = "red"
    A.node_attr["style"] = "filled"
    A.node_attr["shape"] = "circle"
    A.write(G.name + ".dot")

# 将图集中的第20张图绘制为PNG格式
A.draw("A20.png", prog="neato")
